﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace NET4_CS
{

 public class Kunde
 {
  public string Name;
  public string Ort;
  public double Umsatz;
 }

 public class Lieferant
 {
  public string Name;
  public string Ort;
  public List<string> Produkte;
 }

 /// <summary>
 /// Beispiel für das neue Schlüsselwort "dynamic"
 /// </summary>
 class DynamicDemo
 {

  public static void run()
  {


   Kunde k1 = new Kunde() { Name = "Meier", Ort = "Zürich", Umsatz = 10000.00f };
   Kunde k2 = new Kunde() { Name = "Müller", Ort = "Berlin", Umsatz = 20000.00f };
   Lieferant l1 = new Lieferant() { Name = "Schulze", Ort = "Hamburg", Produkte = new List<string> { "Software", "Hardware" } };

   ArrayList Adressen = new ArrayList() { k1, k2, l1 };


   foreach (dynamic d in Adressen)
   {
    Console.WriteLine(d.Name + " aus " + d.Ort);
    if (d is Kunde) Console.WriteLine("  Kunde mit Umsatz: " + d.Umsatz.ToString());
    if (d is Lieferant) Console.WriteLine("  Lieferant mit Produkten: " + String.Join(" ", d.Produkte.ToArray()));
   }

  }

 }
}
