﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;
using System.Diagnostics;

namespace NET4_CS
{

 /// <summary>
 /// Einstaz von PLINQ
 /// </summary>
 class PLINQDemo
 {

  public static int AnzZahlen = 100000;

  /// <summary>
  /// Filtern mit PLINQ
  /// </summary>
  public static void PLINQRun()
  {
   Stopwatch t = new Stopwatch();
   t.Start();
   for (int w = 1; w <= 20; w++)
   {
    int Max = 1000000;
    System.Random rnd = new Random(100);
    List<long> Zahlen = new List<long>();

    for (int i = 1; i < AnzZahlen; i++) Zahlen.Add(rnd.Next());

    var q = from x in Zahlen.AsParallel() where x < (Max / 2) orderby x select x;
    long Groesste = q.Last();
    //Console.WriteLine(w + ": " + Groesste);
   }
   t.Stop();

   Console.WriteLine("PLINQ  = " + t.ElapsedMilliseconds);

  }

  /// <summary>
  /// Filtern mit LINQ ohne PLINQ
  /// </summary>
  public static void LINQRun()
  {
   Stopwatch t = new Stopwatch();
   t.Start();
   for (int w = 1; w <= 20; w++)
   {
    int Max = 1000000;
    System.Random rnd = new Random(100);
    List<long> Zahlen = new List<long>();

    for (int i = 1; i < AnzZahlen; i++) Zahlen.Add(rnd.Next());

    var q = from x in Zahlen where x < (Max / 2) orderby x select x;
    long Groesste = q.Last();
    //Console.WriteLine(w + ": " + Groesste);
   }
   t.Stop();

   Console.WriteLine("LINQ  = " + t.ElapsedMilliseconds);

  }
 }
}
