﻿Imports System.Text
Imports System.Timers

Namespace NET4_CS

 ''' <summary>
 ''' Einstaz von PLINQ
 ''' </summary>
 Friend Class PLINQDemo

  Public Shared AnzZahlen As Integer = 100000

  ''' <summary>
  ''' Filtern mit PLINQ
  ''' </summary>
  Public Shared Sub PLINQRun()
   Dim t As New Stopwatch()
   t.Start()
   For w As Integer = 1 To 20
	Dim Max As Integer = 1000000
	Dim rnd As Random = New Random(100)
	Dim Zahlen As New List(Of Long)()

	For i As Integer = 1 To AnzZahlen - 1
		Zahlen.Add(rnd.Next())
	Next i

	Dim q = From x In Zahlen.AsParallel()
	        Where x < (Max \ 2)
	        Order By x
	        Select x
	Dim Groesste As Long = q.Last()
	'Console.WriteLine(w + ": " + Groesste);
   Next w
   t.Stop()

   Console.WriteLine("PLINQ  = " & t.ElapsedMilliseconds)

  End Sub

  ''' <summary>
  ''' Filtern mit LINQ ohne PLINQ
  ''' </summary>
  Public Shared Sub LINQRun()
   Dim t As New Stopwatch()
   t.Start()
   For w As Integer = 1 To 20
	Dim Max As Integer = 1000000
	Dim rnd As Random = New Random(100)
	Dim Zahlen As New List(Of Long)()

	For i As Integer = 1 To AnzZahlen - 1
		Zahlen.Add(rnd.Next())
	Next i

	Dim q = From x In Zahlen
	        Where x < (Max \ 2)
	        Order By x
	        Select x
	Dim Groesste As Long = q.Last()
	'Console.WriteLine(w + ": " + Groesste);
   Next w
   t.Stop()

   Console.WriteLine("LINQ  = " & t.ElapsedMilliseconds)

  End Sub
 End Class
End Namespace
