﻿Imports System.Text
Imports System.Threading.Tasks
Imports System.Threading

Namespace NET4_CS
 Friend Class TPLDemo

  ''' <summary>
  '''  Parallel.For
  ''' </summary>
  Public Shared Sub RunFor()
   Parallel.For(1, 10, Sub(i) Console.WriteLine(System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & i))
  End Sub

  ''' <summary>
  '''  Parallel.ForEach
  ''' </summary>
  Public Shared Sub RunForEach()
   Dim Zahlen As New List(Of Integer)() From {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}
   Parallel.ForEach(Zahlen, Sub(z) Console.WriteLine(System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & z))
  End Sub

  ''' <summary>
  '''  Parallel.Invoke
  ''' </summary>
  Public Shared Sub RunInvoke()

   ' müssen alle void sein!
   Parallel.Invoke(AddressOf Worker1, AddressOf Worker2, AddressOf Worker3)
  End Sub

  ''' <summary>
  '''  Task.Factory.StartNew
  ''' </summary>
  Public Shared Sub RunFactory()
   Dim t As Task(Of Integer) = Task.Factory.StartNew(Of Integer)(AddressOf Worker4)
   Do While Not t.IsCompleted
	   Console.Write(".")
   Loop
   Console.WriteLine("Result: " & t.Result)
  End Sub

  Public Shared Function Worker4() As Integer
   For i As Integer = 0 To 9
	Console.WriteLine("W1: " & System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & i)
   Next i
   Return 10
  End Function

  Private Shared cts As CancellationTokenSource

  ''' <summary>
  '''  Task.Factory.StartNew mit Abbruch
  ''' </summary>
  Public Shared Sub RunFactoryCancel()
   cts = New CancellationTokenSource()

   ' Starte mit Abbruchoption
   Dim t As Task(Of Integer) = Task.Factory.StartNew(Of Integer)(Function() Worker5(cts.Token))
   Dim i As Integer = 0
   ' Wartet, bis fertig
   Do While Not t.IsCompleted
	i += 1
	Console.Write(".")
	System.Threading.Thread.Sleep(2)
	If i > 30 Then ' künstlicher Abbruch nach 30 Schleifendurchläufen
		cts.Cancel()
	End If
   Loop
   If t.Result = 0 Then
    Console.WriteLine("Thread wurde abgebrochen!")
   Else
    Console.WriteLine("Ergebnis: " & t.Result)
   End If
  End Sub


  Public Shared Function Worker5(ByVal ct As CancellationToken) As Integer
   Dim count As Integer = 0
   For i As Integer = 0 To 9
	count = i
	Console.WriteLine("Worker5 in Thread " & System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & i & ". Schritt!")
	System.Threading.Thread.Sleep(10)
	If ct.IsCancellationRequested Then
		Console.WriteLine("Worker5 in Thread " & System.Threading.Thread.CurrentThread.ManagedThreadId & ": Abruch!")
		Return 0
	End If
   Next i
   Return count
  End Function



  Public Shared Sub Worker1()
   For i As Integer = 0 To 9
	Console.WriteLine("W1: " & System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & i)
   Next i

  End Sub


  Public Shared Sub Worker2()
   For i As Integer = 0 To 9
	Console.WriteLine("W2: " & System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & i)
   Next i
  End Sub


  Public Shared Sub Worker3()
   For i As Integer = 0 To 9
	Console.WriteLine("W3: " & System.Threading.Thread.CurrentThread.ManagedThreadId & ": " & i)
   Next i
  End Sub


  Public Shared Sub LockDemo()
   Dim l As New ReaderWriterLockSlim()

   l.EnterReadLock()

   l.ExitReadLock()

  End Sub
 End Class
End Namespace
