﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace NET4_WCFConsoleHost
{
 class Program
 {
  static void Main(string[] args)
  {
   Console.WriteLine("WCF 4.0 Default Endpoint Demo");
   ServiceHost host = new ServiceHost(typeof(GreetingService),
           new Uri("http://localhost:8080/helloworld"),
           new Uri("net.tcp://localhost:8081/helloworld"));
   host.Open();
   foreach (ServiceEndpoint se in host.Description.Endpoints)
    Console.WriteLine("A: {0}, B: {1}, C: {2}",
        se.Address, se.Binding.Name, se.Contract.Name);
   Console.WriteLine("Warte...");
   Console.ReadLine();
   host.Close();

  }
 }

 [ServiceContract]
 public interface IHello
 {
  [OperationContract]
  void SayHello(string name);
 }
 [ServiceContract]
 public interface IGoodbye
 {
  [OperationContract]
  void SayGoodbye(string name);
 }
 public class GreetingService : IHello, IGoodbye
 {
  public void SayHello(string name)
  {
   Console.WriteLine("Hello {0}", name);
  }
  public void SayGoodbye(string name)
  {
   Console.WriteLine("Goodbye {0}", name);
  }
 }
}
